/*------------------------------------------------------------------------
 * key tables
 */
#include "tcapcommon.h"

/*------------------------------------------------------------------------
 *	The following table is a list of key names and their
 *	associated codes.
 *
 *	Note: more than one name can have the same code, or
 *	another way of looking at it is that a code may have
 *	more than one name for it.
 */
const KEY_DEF tcap_key_tbl[] =
{
	{ "escape",			KEY_ESCAPE			},
	{ "esc",			KEY_ESCAPE			},
	{ "tab",			KEY_TAB				},
	{ "return",			KEY_RETURN			},
	{ "enter",			KEY_RETURN			},
	{ "cr",				KEY_RETURN			},
	{ "bs",				KEY_BS				},
	{ "backspace",		KEY_BS				},
	{ "delete",			KEY_DELETE			},
	{ "del",			KEY_DELETE			},

	{ "kshift",			KEY_KSHIFT			},
	{ "kctrl",			KEY_KCTRL			},
	{ "kalt",			KEY_KALT			},
	{ "kfunc",			KEY_KFUNC			},

	{ "num-lock",		KEY_NUM_LOCK		},
	{ "caps-lock",		KEY_CAPS_LOCK		},
	{ "scroll-lock",	KEY_SCROLL_LOCK		},
	{ "refresh",		KEY_REFRESH			},

	{ "print-screen",	KEY_PRINT_SCREEN	},
	{ "prt-screen",		KEY_PRINT_SCREEN	},
	{ "help",			KEY_HELP			},
	{ "snap",			KEY_SNAP			},

	{ "up",				KEY_UP				},
	{ "down",			KEY_DOWN			},
	{ "left",			KEY_LEFT			},
	{ "right",			KEY_RIGHT			},
	{ "home",			KEY_HOME			},
	{ "end",			KEY_END				},
	{ "pgup",			KEY_PGUP			},
	{ "pgdn",			KEY_PGDN			},
	{ "middle",			KEY_MIDDLE			},
	{ "insert",			KEY_INSERT			},
	{ "ins",			KEY_INSERT			},

	{ "kp0",			KEY_KP0				},
	{ "kp1",			KEY_KP1				},
	{ "kp2",			KEY_KP2				},
	{ "kp3",			KEY_KP3				},
	{ "kp4",			KEY_KP4				},
	{ "kp5",			KEY_KP5				},
	{ "kp6",			KEY_KP6				},
	{ "kp7",			KEY_KP7				},
	{ "kp8",			KEY_KP8				},
	{ "kp9",			KEY_KP9				},
	{ "kpperiod",		KEY_KPPERIOD		},
	{ "kpenter",		KEY_RETURN			},

	{ "user1",			KEY_USER1			},
	{ "user2",			KEY_USER2			},
	{ "user3",			KEY_USER3			},
	{ "user4",			KEY_USER4			},
	{ "user5",			KEY_USER5			},

	{ "f1",				KEY_F1				},
	{ "f2",				KEY_F2				},
	{ "f3",				KEY_F3				},
	{ "f4",				KEY_F4				},
	{ "f5",				KEY_F5				},
	{ "f6",				KEY_F6				},
	{ "f7",				KEY_F7				},
	{ "f8",				KEY_F8				},
	{ "f9",				KEY_F9				},
	{ "f10",			KEY_F10				},
	{ "f11",			KEY_F11				},
	{ "f12",			KEY_F12				},
	{ "f13",			KEY_F13				},
	{ "f14",			KEY_F14				},
	{ "f15",			KEY_F15				},
	{ "f16",			KEY_F16				},

	{ "shift-up",		KEY_SHIFT_UP		},
	{ "shift-down",		KEY_SHIFT_DOWN		},
	{ "shift-left",		KEY_SHIFT_LEFT		},
	{ "shift-right",	KEY_SHIFT_RIGHT		},
	{ "shift-home",		KEY_SHIFT_HOME		},
	{ "shift-end",		KEY_SHIFT_END		},
	{ "shift-pgup",		KEY_SHIFT_PGUP		},
	{ "shift-pgdn",		KEY_SHIFT_PGDN		},
	{ "shift-middle",	KEY_SHIFT_MIDDLE	},

	{ "shift-kp0",		KEY_SHIFT_KP0		},
	{ "shift-kp1",		KEY_SHIFT_KP1		},
	{ "shift-kp2",		KEY_SHIFT_KP2		},
	{ "shift-kp3",		KEY_SHIFT_KP3		},
	{ "shift-kp4",		KEY_SHIFT_KP4		},
	{ "shift-kp5",		KEY_SHIFT_KP5		},
	{ "shift-kp6",		KEY_SHIFT_KP6		},
	{ "shift-kp7",		KEY_SHIFT_KP7		},
	{ "shift-kp8",		KEY_SHIFT_KP8		},
	{ "shift-kp9",		KEY_SHIFT_KP9		},

	{ "shift-user1",	KEY_SHIFT_USER1		},
	{ "shift-user2",	KEY_SHIFT_USER2		},
	{ "shift-user3",	KEY_SHIFT_USER3		},
	{ "shift-user4",	KEY_SHIFT_USER4		},
	{ "shift-user5",	KEY_SHIFT_USER5		},

	{ "shift-bs",		KEY_SHIFT_BS		},
	{ "shift-tab",		KEY_SHIFT_TAB		},
	{ "shift-return",	KEY_SHIFT_RETURN	},

	{ "shift-f1",		KEY_SHIFT_F1		},
	{ "shift-f2",		KEY_SHIFT_F2		},
	{ "shift-f3",		KEY_SHIFT_F3		},
	{ "shift-f4",		KEY_SHIFT_F4		},
	{ "shift-f5",		KEY_SHIFT_F5		},
	{ "shift-f6",		KEY_SHIFT_F6		},
	{ "shift-f7",		KEY_SHIFT_F7		},
	{ "shift-f8",		KEY_SHIFT_F8		},
	{ "shift-f9",		KEY_SHIFT_F9		},
	{ "shift-f10",		KEY_SHIFT_F10		},
	{ "shift-f11",		KEY_SHIFT_F11		},
	{ "shift-f12",		KEY_SHIFT_F12		},
	{ "shift-f13",		KEY_SHIFT_F13		},
	{ "shift-f14",		KEY_SHIFT_F14		},
	{ "shift-f15",		KEY_SHIFT_F15		},
	{ "shift-f16",		KEY_SHIFT_F16		},

	{ "ctrl-up",		KEY_CTRL_UP			},
	{ "ctrl-down",		KEY_CTRL_DOWN		},
	{ "ctrl-left",		KEY_CTRL_LEFT		},
	{ "ctrl-right",		KEY_CTRL_RIGHT		},
	{ "ctrl-home",		KEY_CTRL_HOME		},
	{ "ctrl-end",		KEY_CTRL_END		},
	{ "ctrl-pgup",		KEY_CTRL_PGUP		},
	{ "ctrl-pgdn",		KEY_CTRL_PGDN		},
	{ "ctrl-middle",	KEY_CTRL_MIDDLE		},

	{ "ctrl-kp0",		KEY_CTRL_KP0		},
	{ "ctrl-kp1",		KEY_CTRL_KP1		},
	{ "ctrl-kp2",		KEY_CTRL_KP2		},
	{ "ctrl-kp3",		KEY_CTRL_KP3		},
	{ "ctrl-kp4",		KEY_CTRL_KP4		},
	{ "ctrl-kp5",		KEY_CTRL_KP5		},
	{ "ctrl-kp6",		KEY_CTRL_KP6		},
	{ "ctrl-kp7",		KEY_CTRL_KP7		},
	{ "ctrl-kp8",		KEY_CTRL_KP8		},
	{ "ctrl-kp9",		KEY_CTRL_KP9		},

	{ "ctrl-user1",		KEY_CTRL_USER1		},
	{ "ctrl-user2",		KEY_CTRL_USER2		},
	{ "ctrl-user3",		KEY_CTRL_USER3		},
	{ "ctrl-user4",		KEY_CTRL_USER4		},
	{ "ctrl-user5",		KEY_CTRL_USER5		},

	{ "ctrl-bs",		KEY_CTRL_BS			},
	{ "ctrl-tab",		KEY_CTRL_TAB		},
	{ "ctrl-return",	KEY_CTRL_RETURN		},

	{ "ctrl-f1",		KEY_CTRL_F1			},
	{ "ctrl-f2",		KEY_CTRL_F2			},
	{ "ctrl-f3",		KEY_CTRL_F3			},
	{ "ctrl-f4",		KEY_CTRL_F4			},
	{ "ctrl-f5",		KEY_CTRL_F5			},
	{ "ctrl-f6",		KEY_CTRL_F6			},
	{ "ctrl-f7",		KEY_CTRL_F7			},
	{ "ctrl-f8",		KEY_CTRL_F8			},
	{ "ctrl-f9",		KEY_CTRL_F9			},
	{ "ctrl-f10",		KEY_CTRL_F10		},
	{ "ctrl-f11",		KEY_CTRL_F11		},
	{ "ctrl-f12",		KEY_CTRL_F12		},
	{ "ctrl-f13",		KEY_CTRL_F13		},
	{ "ctrl-f14",		KEY_CTRL_F14		},
	{ "ctrl-f15",		KEY_CTRL_F15		},
	{ "ctrl-f16",		KEY_CTRL_F16		},

	{ "alt-up",			KEY_ALT_UP			},
	{ "alt-down",		KEY_ALT_DOWN		},
	{ "alt-left",		KEY_ALT_LEFT		},
	{ "alt-right",		KEY_ALT_RIGHT		},
	{ "alt-home",		KEY_ALT_HOME		},
	{ "alt-end",		KEY_ALT_END			},
	{ "alt-pgup",		KEY_ALT_PGUP		},
	{ "alt-pgdn",		KEY_ALT_PGDN		},
	{ "alt-middle",		KEY_ALT_MIDDLE		},

	{ "alt-kp0",		KEY_ALT_KP0			},
	{ "alt-kp1",		KEY_ALT_KP1			},
	{ "alt-kp2",		KEY_ALT_KP2			},
	{ "alt-kp3",		KEY_ALT_KP3			},
	{ "alt-kp4",		KEY_ALT_KP4			},
	{ "alt-kp5",		KEY_ALT_KP5			},
	{ "alt-kp6",		KEY_ALT_KP6			},
	{ "alt-kp7",		KEY_ALT_KP7			},
	{ "alt-kp8",		KEY_ALT_KP8			},
	{ "alt-kp9",		KEY_ALT_KP9			},

	{ "alt-user1",		KEY_ALT_USER1		},
	{ "alt-user2",		KEY_ALT_USER2		},
	{ "alt-user3",		KEY_ALT_USER3		},
	{ "alt-user4",		KEY_ALT_USER4		},
	{ "alt-user5",		KEY_ALT_USER5		},

	{ "alt-bs",			KEY_ALT_BS			},
	{ "alt-tab",		KEY_ALT_TAB			},
	{ "alt-return",		KEY_ALT_RETURN		},

	{ "alt-f1",			KEY_ALT_F1			},
	{ "alt-f2",			KEY_ALT_F2			},
	{ "alt-f3",			KEY_ALT_F3			},
	{ "alt-f4",			KEY_ALT_F4			},
	{ "alt-f5",			KEY_ALT_F5			},
	{ "alt-f6",			KEY_ALT_F6			},
	{ "alt-f7",			KEY_ALT_F7			},
	{ "alt-f8",			KEY_ALT_F8			},
	{ "alt-f9",			KEY_ALT_F9			},
	{ "alt-f10",		KEY_ALT_F10			},
	{ "alt-f11",		KEY_ALT_F11			},
	{ "alt-f12",		KEY_ALT_F12			},
	{ "alt-f13",		KEY_ALT_F13			},
	{ "alt-f14",		KEY_ALT_F14			},
	{ "alt-f15",		KEY_ALT_F15			},
	{ "alt-f16",		KEY_ALT_F16			},

	{ "alt-0",			KEY_ALT_0			},
	{ "alt-1",			KEY_ALT_1			},
	{ "alt-2",			KEY_ALT_2			},
	{ "alt-3",			KEY_ALT_3			},
	{ "alt-4",			KEY_ALT_4			},
	{ "alt-5",			KEY_ALT_5			},
	{ "alt-6",			KEY_ALT_6			},
	{ "alt-7",			KEY_ALT_7			},
	{ "alt-8",			KEY_ALT_8			},
	{ "alt-9",			KEY_ALT_9			},

	{ "alt-a",			KEY_ALT_A			},
	{ "alt-b",			KEY_ALT_B			},
	{ "alt-c",			KEY_ALT_C			},
	{ "alt-d",			KEY_ALT_D			},
	{ "alt-e",			KEY_ALT_E			},
	{ "alt-f",			KEY_ALT_F			},
	{ "alt-g",			KEY_ALT_G			},
	{ "alt-h",			KEY_ALT_H			},
	{ "alt-i",			KEY_ALT_I			},
	{ "alt-j",			KEY_ALT_J			},
	{ "alt-k",			KEY_ALT_K			},
	{ "alt-l",			KEY_ALT_L			},
	{ "alt-m",			KEY_ALT_M			},
	{ "alt-n",			KEY_ALT_N			},
	{ "alt-o",			KEY_ALT_O			},
	{ "alt-p",			KEY_ALT_P			},
	{ "alt-q",			KEY_ALT_Q			},
	{ "alt-r",			KEY_ALT_R			},
	{ "alt-s",			KEY_ALT_S			},
	{ "alt-t",			KEY_ALT_T			},
	{ "alt-u",			KEY_ALT_U			},
	{ "alt-v",			KEY_ALT_V			},
	{ "alt-w",			KEY_ALT_W			},
	{ "alt-x",			KEY_ALT_X			},
	{ "alt-y",			KEY_ALT_Y			},
	{ "alt-z",			KEY_ALT_Z			},

	{ "mouse-event",	KEY_MOUSE			},

	{ "mouse-lbu",		MOUSE_LBU			},
	{ "mouse-lbd",		MOUSE_LBD			},
	{ "mouse-lbdbl",	MOUSE_LBDBL			},
	{ "mouse-mbu",		MOUSE_MBU			},
	{ "mouse-mbd",		MOUSE_MBD			},
	{ "mouse-mbdbl",	MOUSE_MBDBL			},
	{ "mouse-rbu",		MOUSE_RBU			},
	{ "mouse-rbd",		MOUSE_RBD			},
	{ "mouse-rbdbl",	MOUSE_RBDBL			},

	{ "mouse-move",		MOUSE_MOVE			},
	{ "mouse-drag",		MOUSE_DRAG			},

	{ "mouse-left",		MOUSE_LEFT			},
	{ "mouse-right",	MOUSE_RIGHT			},
	{ "mouse-up",		MOUSE_UP			},
	{ "mouse-down",		MOUSE_DOWN			},

	{ "mouse-ul",		MOUSE_UL			},
	{ "mouse-ur",		MOUSE_UR			},
	{ "mouse-dl",		MOUSE_DL			},
	{ "mouse-dr",		MOUSE_DR			},

	{ "mouse-scrollup",	MOUSE_SCROLLUP		},
	{ "mouse-scrolldn",	MOUSE_SCROLLDN		},

	{ "unknown",		KEY_UNKNOWN			},
	{ "read-again",		KEY_READ_AGAIN		},
	{ "win-resize",		KEY_WINRESIZE		},
	{ "timer",			KEY_TIMER			},
	{ "signal",			KEY_SIGNAL			},

	{ "shift-press",	KEY_SHIFT_PRESS		},
	{ "shift-release",	KEY_SHIFT_RELEASE	},

	{ "ctrl-press",		KEY_CTRL_PRESS		},
	{ "ctrl-release",	KEY_CTRL_RELEASE	},

	{ "alt-press",		KEY_ALT_PRESS		},
	{ "alt-release",	KEY_ALT_RELEASE		},

	{ 0, 0 }
};
