/*------------------------------------------------------------------------
 * termcap/terminfo database names
 */
#include <string.h>
#include "wtcinfo.h"

/*------------------------------------------------------------------------
 * termcap/terminfo info structs
 */
const TC_INFO	tc_bools[] =
{
	{ "bw",			"bw",	"auto_left_margin"			},
	{ "am",			"am",	"auto_right_margin"			},
	{ "xsb",		"xb",	"no_esc_ctlc"				},
	{ "xhp",		"xs",	"ceol_standout_glitch"		},
	{ "xenl",		"xn",	"eat_newline_glitch"		},
	{ "eo",			"eo",	"erase_overstrike"			},
	{ "gn",			"gn",	"generic_type"				},
	{ "hc",			"hc",	"hard_copy"					},
	{ "km",			"km",	"has_meta_key"				},
	{ "hs",			"hs",	"has_status_line"			},
	{ "in",			"in",	"insert_null_glitch"		},
	{ "da",			"da",	"memory_above"				},
	{ "db",			"db",	"memory_below"				},
	{ "mir",		"mi",	"move_insert_mode"			},
	{ "msgr",		"ms",	"move_standout_mode"		},
	{ "os",			"os",	"over_strike"				},
	{ "eslok",		"es",	"status_line_esc_ok"		},
	{ "xt",			"xt",	"dest_tabs_magic_smso"		},
	{ "hz",			"hz",	"tilde_glitch"				},
	{ "ul",			"ul",	"transparent_underline"		},
	{ "xon",		"xo",	"xon_xoff"					},
	{ "nxon",		"nx",	"needs_xon_xoff"			},
	{ "mc5i",		"5i",	"prtr_silent"				},
	{ "chts",		"HC",	"hard_cursor"				},
	{ "nrrmc",		"NR",	"non_rev_rmcup"				},
	{ "npc",		"NP",	"no_pad_char"				},
	{ "ndscr",		"ND",	"non_dest_scroll_region"	},
	{ "ccc",		"cc",	"can_change"				},
	{ "bce",		"ut",	"back_color_erase"			},
	{ "hls",		"hl",	"hue_lightness_saturation"	},
	{ "xhpa",		"YA",	"col_addr_glitch"			},
	{ "crxm",		"YB",	"cr_cancels_micro_mode"		},
	{ "daisy",		"YC",	"has_print_wheel"			},
	{ "xvpa",		"YD",	"row_addr_glitch"			},
	{ "sam",		"YE",	"semi_auto_right_margin"	},
	{ "cpix",		"YF",	"cpi_changes_res"			},
	{ "lpix",		"YG",	"lpi_changes_res"			},

	{ 0, 0, 0 }
};
const int	num_tc_bools = (sizeof(tc_bools) / sizeof(*tc_bools)) - 1;

const TC_INFO tc_nums[] =
{
	{ "cols",		"co",	"columns"					},
	{ "it",			"it",	"init_tabs"					},
	{ "lines",		"li",	"lines"						},
	{ "lm",			"lm",	"lines_of_memory"			},
	{ "xmc",		"sg",	"magic_cookie_glitch"		},
	{ "pb",			"pb",	"padding_baud_rate"			},
	{ "vt",			"vt",	"virtual_terminal"			},
	{ "wsl",		"ws",	"width_status_line"			},
	{ "nlab",		"Nl",	"num_labels"				},
	{ "lh",			"lh",	"label_height"				},
	{ "lw",			"lw",	"label_width"				},
	{ "ma",			"ma",	"max_attributes"			},
	{ "wnum",		"MW",	"maximum_windows"			},
	{ "colors",		"Co",	"max_colors"				},
	{ "pairs",		"pa",	"max_pairs"					},
	{ "ncv",		"NC",	"no_color_video"			},
	{ "bufsz",		"Ya",	"buffer_capacity"			},
	{ "spinv",		"Yb",	"dot_vert_spacing"			},
	{ "spinh",		"Yc",	"dot_horz_spacing"			},
	{ "maddr",		"Yd",	"max_micro_address"			},
	{ "mjump",		"Ye",	"max_micro_jump"			},
	{ "mcs",		"Yf",	"micro_char_size"			},
	{ "mls",		"Yg",	"micro_line_size"			},
	{ "npins",		"Yh",	"number_of_pins"			},
	{ "orc",		"Yi",	"output_res_char"			},
	{ "orl",		"Yj",	"output_res_line"			},
	{ "orhi",		"Yk",	"output_res_horz_inch"		},
	{ "orvi",		"Yl",	"output_res_vert_inch"		},
	{ "cps",		"Ym",	"print_rate"				},
	{ "widcs",		"Yn",	"wide_char_size"			},
	{ "btns",		"BT",	"buttons"					},
	{ "bitwin",		"Yo",	"bit_image_entwining"		},
	{ "bitype",		"Yp",	"bit_image_type"			},

	{ 0, 0, 0 }
};
const int	num_tc_nums	= (sizeof(tc_nums) / sizeof(*tc_nums)) - 1;

const TC_INFO tc_strs[] =
{
	{ "cbt",		"bt",	"back_tab"					},
	{ "bel",		"bl",	"bell"						},
	{ "cr",			"cr",	"carriage_return"			},
	{ "csr",		"cs",	"change_scroll_region"		},
	{ "tbc",		"ct",	"clear_all_tabs"			},
	{ "clear",		"cl",	"clear_screen"				},
	{ "el",			"ce",	"clr_eol"					},
	{ "ed",			"cd",	"clr_eos"					},
	{ "hpa",		"ch",	"column_address"			},
	{ "cmdch",		"CC",	"command_character"			},
	{ "cup",		"cm",	"cursor_address"			},
	{ "cud1",		"do",	"cursor_down"				},
	{ "home",		"ho",	"cursor_home"				},
	{ "civis",		"vi",	"cursor_invisible"			},
	{ "cub1",		"le",	"cursor_left"				},
	{ "mrcup",		"CM",	"cursor_mem_address"		},
	{ "cnorm",		"ve",	"cursor_normal"				},
	{ "cuf1",		"nd",	"cursor_right"				},
	{ "ll",			"ll",	"cursor_to_ll"				},
	{ "cuu1",		"up",	"cursor_up"					},
	{ "cvvis",		"vs",	"cursor_visible"			},
	{ "dch1",		"dc",	"delete_character"			},
	{ "dl1",		"dl",	"delete_line"				},
	{ "dsl",		"ds",	"dis_status_line"			},
	{ "hd",			"hd",	"down_half_line"			},
	{ "smacs",		"as",	"enter_alt_charset_mode"	},
	{ "blink",		"mb",	"enter_blink_mode"			},
	{ "bold",		"md",	"enter_bold_mode"			},
	{ "smcup",		"ti",	"enter_ca_mode"				},
	{ "smdc",		"dm",	"enter_delete_mode"			},
	{ "dim",		"mh",	"enter_dim_mode"			},
	{ "smir",		"im",	"enter_insert_mode"			},
	{ "invis",		"mk",	"enter_secure_mode"			},
	{ "prot",		"mp",	"enter_protected_mode"		},
	{ "rev",		"mr",	"enter_reverse_mode"		},
	{ "smso",		"so",	"enter_standout_mode"		},
	{ "smul",		"us",	"enter_underline_mode"		},
	{ "ech",		"ec",	"erase_chars"				},
	{ "rmacs",		"ae",	"exit_alt_charset_mode"		},
	{ "sgr0",		"me",	"exit_attribute_mode"		},
	{ "rmcup",		"te",	"exit_ca_mode"				},
	{ "rmdc",		"ed",	"exit_delete_mode"			},
	{ "rmir",		"ei",	"exit_insert_mode"			},
	{ "rmso",		"se",	"exit_standout_mode"		},
	{ "rmul",		"ue",	"exit_underline_mode"		},
	{ "flash",		"vb",	"flash_screen"				},
	{ "ff",			"ff",	"form_feed"					},
	{ "fsl",		"fs",	"from_status_line"			},
	{ "is1",		"i1",	"init_1string"				},
	{ "is2",		"is",	"init_2string"				},
	{ "is3",		"i3",	"init_3string"				},
	{ "if",			"if",	"init_file"					},
	{ "ich1",		"ic",	"insert_character"			},
	{ "il1",		"al",	"insert_line"				},
	{ "ip",			"ip",	"insert_padding"			},
	{ "kbs",		"kb",	"key_backspace"				},
	{ "ktbc",		"ka",	"key_catab"					},
	{ "kclr",		"kC",	"key_clear"					},
	{ "kctab",		"kt",	"key_ctab"					},
	{ "kdch1",		"kD",	"key_dc"					},
	{ "kdl1",		"kL",	"key_dl"					},
	{ "kcud1",		"kd",	"key_down"					},
	{ "krmir",		"kM",	"key_eic"					},
	{ "kel",		"kE",	"key_eol"					},
	{ "ked",		"kS",	"key_eos"					},
	{ "kf0",		"k0",	"key_f0"					},
	{ "kf1",		"k1",	"key_f1"					},
	{ "kf10",		"k;",	"key_f10"					},
	{ "kf2",		"k2",	"key_f2"					},
	{ "kf3",		"k3",	"key_f3"					},
	{ "kf4",		"k4",	"key_f4"					},
	{ "kf5",		"k5",	"key_f5"					},
	{ "kf6",		"k6",	"key_f6"					},
	{ "kf7",		"k7",	"key_f7"					},
	{ "kf8",		"k8",	"key_f8"					},
	{ "kf9",		"k9",	"key_f9"					},
	{ "khome",		"kh",	"key_home"					},
	{ "kich1",		"kI",	"key_ic"					},
	{ "kil1",		"kA",	"key_il"					},
	{ "kcub1",		"kl",	"key_left"					},
	{ "kll",		"kH",	"key_ll"					},
	{ "knp",		"kN",	"key_npage"					},
	{ "kpp",		"kP",	"key_ppage"					},
	{ "kcuf1",		"kr",	"key_right"					},
	{ "kind",		"kF",	"key_sf"					},
	{ "kri",		"kR",	"key_sr"					},
	{ "khts",		"kT",	"key_stab"					},
	{ "kcuu1",		"ku",	"key_up"					},
	{ "rmkx",		"ke",	"keypad_local"				},
	{ "smkx",		"ks",	"keypad_xmit"				},
	{ "lf0",		"l0",	"lab_f0"					},
	{ "lf1",		"l1",	"lab_f1"					},
	{ "lf10",		"la",	"lab_f10"					},
	{ "lf2",		"l2",	"lab_f2"					},
	{ "lf3",		"l3",	"lab_f3"					},
	{ "lf4",		"l4",	"lab_f4"					},
	{ "lf5",		"l5",	"lab_f5"					},
	{ "lf6",		"l6",	"lab_f6"					},
	{ "lf7",		"l7",	"lab_f7"					},
	{ "lf8",		"l8",	"lab_f8"					},
	{ "lf9",		"l9",	"lab_f9"					},
	{ "rmm",		"mo",	"meta_off"					},
	{ "smm",		"mm",	"meta_on"					},
	{ "nel",		"nw",	"newline"					},
	{ "pad",		"pc",	"pad_char"					},
	{ "dch",		"DC",	"parm_dch"					},
	{ "dl",			"DL",	"parm_delete_line"			},
	{ "cud",		"DO",	"parm_down_cursor"			},
	{ "ich",		"IC",	"parm_ich"					},
	{ "indn",		"SF",	"parm_index"				},
	{ "il",			"AL",	"parm_insert_line"			},
	{ "cub",		"LE",	"parm_left_cursor"			},
	{ "cuf",		"RI",	"parm_right_cursor"			},
	{ "rin",		"SR",	"parm_rindex"				},
	{ "cuu",		"UP",	"parm_up_cursor"			},
	{ "pfkey",		"pk",	"pkey_key"					},
	{ "pfloc",		"pl",	"pkey_local"				},
	{ "pfx",		"px",	"pkey_xmit"					},
	{ "mc0",		"ps",	"print_screen"				},
	{ "mc4",		"pf",	"prtr_off"					},
	{ "mc5",		"po",	"prtr_on"					},
	{ "rep",		"rp",	"repeat_char"				},
	{ "rs1",		"r1",	"reset_1string"				},
	{ "rs2",		"r2",	"reset_2string"				},
	{ "rs3",		"r3",	"reset_3string"				},
	{ "rf",			"rf",	"reset_file"				},
	{ "rc",			"rc",	"restore_cursor"			},
	{ "vpa",		"cv",	"row_address"				},
	{ "sc",			"sc",	"save_cursor"				},
	{ "ind",		"sf",	"scroll_forward"			},
	{ "ri",			"sr",	"scroll_reverse"			},
	{ "sgr",		"sa",	"set_attributes"			},
	{ "hts",		"st",	"set_tab"					},
	{ "wind",		"wi",	"set_window"				},
	{ "ht",			"ta",	"tab"						},
	{ "tsl",		"ts",	"to_status_line"			},
	{ "uc",			"uc",	"underline_char"			},
	{ "hu",			"hu",	"up_half_line"				},
	{ "iprog",		"iP",	"init_prog"					},
	{ "ka1",		"K1",	"key_a1"					},
	{ "ka3",		"K3",	"key_a3"					},
	{ "kb2",		"K2",	"key_b2"					},
	{ "kc1",		"K4",	"key_c1"					},
	{ "kc3",		"K5",	"key_c3"					},
	{ "mc5p",		"pO",	"prtr_non"					},
	{ "rmp",		"rP",	"char_padding"				},
	{ "acsc",		"ac",	"acs_chars"					},
	{ "pln",		"pn",	"plab_norm"					},
	{ "kcbt",		"kB",	"key_btab"					},
	{ "smxon",		"SX",	"enter_xon_mode"			},
	{ "rmxon",		"RX",	"exit_xon_mode"				},
	{ "smam",		"SA",	"enter_am_mode"				},
	{ "rmam",		"RA",	"exit_am_mode"				},
	{ "xonc",		"XN",	"xon_character"				},
	{ "xoffc",		"XF",	"xoff_character"			},
	{ "enacs",		"eA",	"ena_acs"					},
	{ "smln",		"LO",	"label_on"					},
	{ "rmln",		"LF",	"label_off"					},
	{ "kbeg",		"@1",	"key_beg"					},
	{ "kcan",		"@2",	"key_cancel"				},
	{ "kclo",		"@3",	"key_close"					},
	{ "kcmd",		"@4",	"key_command"				},
	{ "kcpy",		"@5",	"key_copy"					},
	{ "kcrt",		"@6",	"key_create"				},
	{ "kend",		"@7",	"key_end"					},
	{ "kent",		"@8",	"key_enter"					},
	{ "kext",		"@9",	"key_exit"					},
	{ "kfnd",		"@0",	"key_find"					},
	{ "khlp",		"%1",	"key_help"					},
	{ "kmrk",		"%2",	"key_mark"					},
	{ "kmsg",		"%3",	"key_message"				},
	{ "kmov",		"%4",	"key_move"					},
	{ "knxt",		"%5",	"key_next"					},
	{ "kopn",		"%6",	"key_open"					},
	{ "kopt",		"%7",	"key_options"				},
	{ "kprv",		"%8",	"key_previous"				},
	{ "kprt",		"%9",	"key_print"					},
	{ "krdo",		"%0",	"key_redo"					},
	{ "kref",		"&1",	"key_reference"				},
	{ "krfr",		"&2",	"key_refresh"				},
	{ "krpl",		"&3",	"key_replace"				},
	{ "krst",		"&4",	"key_restart"				},
	{ "kres",		"&5",	"key_resume"				},
	{ "ksav",		"&6",	"key_save"					},
	{ "kspd",		"&7",	"key_suspend"				},
	{ "kund",		"&8",	"key_undo"					},
	{ "kBEG",		"&9",	"key_sbeg"					},
	{ "kCAN",		"&0",	"key_scancel"				},
	{ "kCMD",		"*1",	"key_scommand"				},
	{ "kCPY",		"*2",	"key_scopy"					},
	{ "kCRT",		"*3",	"key_screate"				},
	{ "kDC",		"*4",	"key_sdc"					},
	{ "kDL",		"*5",	"key_sdl"					},
	{ "kslt",		"*6",	"key_select"				},
	{ "kEND",		"*7",	"key_send"					},
	{ "kEOL",		"*8",	"key_seol"					},
	{ "kEXT",		"*9",	"key_sexit"					},
	{ "kFND",		"*0",	"key_sfind"					},
	{ "kHLP",		"#1",	"key_shelp"					},
	{ "kHOM",		"#2",	"key_shome"					},
	{ "kIC",		"#3",	"key_sic"					},
	{ "kLFT",		"#4",	"key_sleft"					},
	{ "kMSG",		"%a",	"key_smessage"				},
	{ "kMOV",		"%b",	"key_smove"					},
	{ "kNXT",		"%c",	"key_snext"					},
	{ "kOPT",		"%d",	"key_soptions"				},
	{ "kPRV",		"%e",	"key_sprevious"				},
	{ "kPRT",		"%f",	"key_sprint"				},
	{ "kRDO",		"%g",	"key_sredo"					},
	{ "kRPL",		"%h",	"key_sreplace"				},
	{ "kRIT",		"%i",	"key_sright"				},
	{ "kRES",		"%j",	"key_srsume"				},
	{ "kSAV",		"!1",	"key_ssave"					},
	{ "kSPD",		"!2",	"key_ssuspend"				},
	{ "kUND",		"!3",	"key_sundo"					},
	{ "rfi",		"RF",	"req_for_input"				},
	{ "kf11",		"F1",	"key_f11"					},
	{ "kf12",		"F2",	"key_f12"					},
	{ "kf13",		"F3",	"key_f13"					},
	{ "kf14",		"F4",	"key_f14"					},
	{ "kf15",		"F5",	"key_f15"					},
	{ "kf16",		"F6",	"key_f16"					},
	{ "kf17",		"F7",	"key_f17"					},
	{ "kf18",		"F8",	"key_f18"					},
	{ "kf19",		"F9",	"key_f19"					},
	{ "kf20",		"FA",	"key_f20"					},
	{ "kf21",		"FB",	"key_f21"					},
	{ "kf22",		"FC",	"key_f22"					},
	{ "kf23",		"FD",	"key_f23"					},
	{ "kf24",		"FE",	"key_f24"					},
	{ "kf25",		"FF",	"key_f25"					},
	{ "kf26",		"FG",	"key_f26"					},
	{ "kf27",		"FH",	"key_f27"					},
	{ "kf28",		"FI",	"key_f28"					},
	{ "kf29",		"FJ",	"key_f29"					},
	{ "kf30",		"FK",	"key_f30"					},
	{ "kf31",		"FL",	"key_f31"					},
	{ "kf32",		"FM",	"key_f32"					},
	{ "kf33",		"FN",	"key_f33"					},
	{ "kf34",		"FO",	"key_f34"					},
	{ "kf35",		"FP",	"key_f35"					},
	{ "kf36",		"FQ",	"key_f36"					},
	{ "kf37",		"FR",	"key_f37"					},
	{ "kf38",		"FS",	"key_f38"					},
	{ "kf39",		"FT",	"key_f39"					},
	{ "kf40",		"FU",	"key_f40"					},
	{ "kf41",		"FV",	"key_f41"					},
	{ "kf42",		"FW",	"key_f42"					},
	{ "kf43",		"FX",	"key_f43"					},
	{ "kf44",		"FY",	"key_f44"					},
	{ "kf45",		"FZ",	"key_f45"					},
	{ "kf46",		"Fa",	"key_f46"					},
	{ "kf47",		"Fb",	"key_f47"					},
	{ "kf48",		"Fc",	"key_f48"					},
	{ "kf49",		"Fd",	"key_f49"					},
	{ "kf50",		"Fe",	"key_f50"					},
	{ "kf51",		"Ff",	"key_f51"					},
	{ "kf52",		"Fg",	"key_f52"					},
	{ "kf53",		"Fh",	"key_f53"					},
	{ "kf54",		"Fi",	"key_f54"					},
	{ "kf55",		"Fj",	"key_f55"					},
	{ "kf56",		"Fk",	"key_f56"					},
	{ "kf57",		"Fl",	"key_f57"					},
	{ "kf58",		"Fm",	"key_f58"					},
	{ "kf59",		"Fn",	"key_f59"					},
	{ "kf60",		"Fo",	"key_f60"					},
	{ "kf61",		"Fp",	"key_f61"					},
	{ "kf62",		"Fq",	"key_f62"					},
	{ "kf63",		"Fr",	"key_f63"					},
	{ "el1",		"cb",	"clr_bol"					},
	{ "mgc",		"MC",	"clear_margins"				},
	{ "smgl",		"ML",	"set_left_margin"			},
	{ "smgr",		"MR",	"set_right_margin"			},
	{ "fln",		"Lf",	"label_format"				},
	{ "sclk",		"SC",	"set_clock"					},
	{ "dclk",		"DK",	"display_clock"				},
	{ "rmclk",		"RC",	"remove_clock"				},
	{ "cwin",		"CW",	"create_window"				},
	{ "wingo",		"WG",	"goto_window"				},
	{ "hup",		"HU",	"hangup"					},
	{ "dial",		"DI",	"dial_phone"				},
	{ "qdial",		"QD",	"quick_dial"				},
	{ "tone",		"TO",	"tone"						},
	{ "pulse",		"PU",	"pulse"						},
	{ "hook",		"fh",	"flash_hook"				},
	{ "pause",		"PA",	"fixed_pause"				},
	{ "wait",		"WA",	"wait_tone"					},
	{ "u0",			"u0",	"user0"						},
	{ "u1",			"u1",	"user1"						},
	{ "u2",			"u2",	"user2"						},
	{ "u3",			"u3",	"user3"						},
	{ "u4",			"u4",	"user4"						},
	{ "u5",			"u5",	"user5"						},
	{ "u6",			"u6",	"user6"						},
	{ "u7",			"u7",	"user7"						},
	{ "u8",			"u8",	"user8"						},
	{ "u9",			"u9",	"user9"						},
	{ "op",			"op",	"orig_pair"					},
	{ "oc",			"oc",	"orig_colors"				},
	{ "initc",		"Ic",	"initialize_color"			},
	{ "initp",		"Ip",	"initialize_pair"			},
	{ "scp",		"sp",	"set_color_pair"			},
	{ "setf",		"Sf",	"set_foreground"			},
	{ "setb",		"Sb",	"set_background"			},
	{ "cpi",		"ZA",	"change_char_pitch"			},
	{ "lpi",		"ZB",	"change_line_pitch"			},
	{ "chr",		"ZC",	"change_res_horz"			},
	{ "cvr",		"ZD",	"change_res_vert"			},
	{ "defc",		"ZE",	"define_char"				},
	{ "swidm",		"ZF",	"enter_doublewide_mode"		},
	{ "sdrfq",		"ZG",	"enter_draft_quality"		},
	{ "sitm",		"ZH",	"enter_italics_mode"		},
	{ "slm",		"ZI",	"enter_leftward_mode"		},
	{ "smicm",		"ZJ",	"enter_micro_mode"			},
	{ "snlq",		"ZK",	"enter_near_letter_quality"	},
	{ "snrmq",		"ZL",	"enter_normal_quality"		},
	{ "sshm",		"ZM",	"enter_shadow_mode"			},
	{ "ssubm",		"ZN",	"enter_subscript_mode"		},
	{ "ssupm",		"ZO",	"enter_superscript_mode"	},
	{ "sum",		"ZP",	"enter_upward_mode"			},
	{ "rwidm",		"ZQ",	"exit_doublewide_mode"		},
	{ "ritm",		"ZR",	"exit_italics_mode"			},
	{ "rlm",		"ZS",	"exit_leftward_mode"		},
	{ "rmicm",		"ZT",	"exit_micro_mode"			},
	{ "rshm",		"ZU",	"exit_shadow_mode"			},
	{ "rsubm",		"ZV",	"exit_subscript_mode"		},
	{ "rsupm",		"ZW",	"exit_superscript_mode"		},
	{ "rum",		"ZX",	"exit_upward_mode"			},
	{ "mhpa",		"ZY",	"micro_column_address"		},
	{ "mcud1",		"ZZ",	"micro_down"				},
	{ "mcub1",		"Za",	"micro_left"				},
	{ "mcuf1",		"Zb",	"micro_right"				},
	{ "mvpa",		"Zc",	"micro_row_address"			},
	{ "mcuu1",		"Zd",	"micro_up"					},
	{ "porder",		"Ze",	"order_of_pins"				},
	{ "mcud",		"Zf",	"parm_down_micro"			},
	{ "mcub",		"Zg",	"parm_left_micro"			},
	{ "mcuf",		"Zh",	"parm_right_micro"			},
	{ "mcuu",		"Zi",	"parm_up_micro"				},
	{ "scs",		"Zj",	"select_char_set"			},
	{ "smgb",		"Zk",	"set_bottom_margin"			},
	{ "smgbp",		"Zl",	"set_bottom_margin_parm"	},
	{ "smglp",		"Zm",	"set_left_margin_parm"		},
	{ "smgrp",		"Zn",	"set_right_margin_parm"		},
	{ "smgt",		"Zo",	"set_top_margin"			},
	{ "smgtp",		"Zp",	"set_top_margin_parm"		},
	{ "sbim",		"Zq",	"start_bit_image"			},
	{ "scsd",		"Zr",	"start_char_set_def"		},
	{ "rbim",		"Zs",	"stop_bit_image"			},
	{ "rcsd",		"Zt",	"stop_char_set_def"			},
	{ "subcs",		"Zu",	"subscript_characters"		},
	{ "supcs",		"Zv",	"superscript_characters"	},
	{ "docr",		"Zw",	"these_cause_cr"			},
	{ "zerom",		"Zx",	"zero_motion"				},
	{ "csnm",		"Zy",	"char_set_names"			},
	{ "kmous",		"Km",	"key_mouse"					},
	{ "minfo",		"Mi",	"mouse_info"				},
	{ "reqmp",		"RQ",	"req_mouse_pos"				},
	{ "getm",		"Gm",	"get_mouse"					},
	{ "setaf",		"AF",	"set_a_foreground"			},
	{ "setab",		"AB",	"set_a_background"			},
	{ "pfxl",		"xl",	"pkey_plab"					},
	{ "devt",		"dv",	"device_type"				},
	{ "csin",		"ci",	"code_set_init"				},
	{ "s0ds",		"s0",	"set0_des_seq"				},
	{ "s1ds",		"s1",	"set1_des_seq"				},
	{ "s2ds",		"s2",	"set2_des_seq"				},
	{ "s3ds",		"s3",	"set3_des_seq"				},
	{ "smglr",		"ML",	"set_lr_margin"				},
	{ "smgtb",		"MT",	"set_tb_margin"				},
	{ "birep",		"Xy",	"bit_image_repeat"			},
	{ "binel",		"Zz",	"bit_image_newline"			},
	{ "bicr",		"Yv",	"bit_image_carriage_return"	},
	{ "colornm",	"Yw",	"color_names"				},
	{ "defbi",		"Yx",	"define_bit_image_region"	},
	{ "endbi",		"Yy",	"end_bit_image_region"		},
	{ "setcolor",	"Yz",	"set_color_band"			},
	{ "slines",		"YZ",	"set_page_length"			},
	{ "dispc",		"S1",	"display_pc_char"			},
	{ "smpch",		"S2",	"enter_pc_charset_mode"		},
	{ "rmpch",		"S3",	"exit_pc_charset_mode"		},
	{ "smsc",		"S4",	"enter_scancode_mode"		},
	{ "rmsc",		"S5",	"exit_scancode_mode"		},
	{ "pctrm",		"S6",	"pc_term_options"			},
	{ "scesc",		"S7",	"scancode_escape"			},
	{ "scesa",		"S8",	"alt_scancode_esc"			},
	{ "ehhlm",		"??",	"enter_horizontal_hl_mode"	},
	{ "elhlm",		"??",	"enter_left_hl_mode"		},
	{ "elohlm",		"??",	"enter_low_hl_mode"			},
	{ "erhlm",		"??",	"enter_right_hl_mode"		},
	{ "ethlm",		"??",	"enter_top_hl_mode"			},
	{ "evhlm",		"??",	"enter_vertical_hl_mode"	},
	{ "sgr1",		"??",	"set_a_attributes"			},
	{ "slength",	"YI",	"set_pglen_inch"			},

	{ 0, 0, 0 }
};
const int	num_tc_strs	= (sizeof(tc_strs) / sizeof(*tc_strs)) - 1;

/*------------------------------------------------------------------------
 * functions to get id from a name
 */
static int tc_id_lookup (const char *id, const TC_INFO *tbl)
{
	const TC_INFO *	t;

	if (id == 0 || *id == 0)
		return (-1);

	for (t=tbl; t->ti_name; t++)
	{
		if (strcmp(id, t->ti_name) == 0 ||
		    strcmp(id, t->tc_name) == 0 ||
		    strcmp(id, t->desc)    == 0)
		{
			return (t - tbl);
		}
	}

	return (-1);
}

int tc_id_flag (const char *id)
{
	return tc_id_lookup(id, tc_bools);
}

int tc_id_num (const char *id)
{
	return tc_id_lookup(id, tc_nums);
}

int tc_id_str (const char *id)
{
	return tc_id_lookup(id, tc_strs);
}
